// PS2/PSP Input Machine  by Kako

#include <stdio.h>
#include "uart.h"
#include <avr/io.h>

int main()
{
	int i,recv_flag,cnt;
	char buf[80],c,c1,c2,c3;
	unsigned char d1,d2,d3;
	unsigned char out1,out2,out3;
	
	// I/O port init
	DDRB |= 0b00111111; /* In/Out direction  1...Output / 0...Input */
	DDRC |= 0b00111111; /* In/Out direction  1...Output / 0...Input */
	DDRD |= 0b11111100; /* In/Out direction  1...Output / 0...Input */
	PORTB = 0x00; /* out pins  */
	PORTC = 0x00; /* out pins  */
	PORTD = 0x00; /* out pins  */
	
	// UART init
	rs_init(57600);
	
	rs_puts("PS2/PSP Input Machine  by Kako \n");
	
	i=0;
	while (1) {
		recv_flag=0;
		
		if (rs_size()>0 ) {
			c=rs_getc(buf);
			buf[i]=c;
			if (i<=2) { i++; }
			if (c==0x0d) {
				recv_flag=1; buf[i]='\0'; i=0; 
			}
		}
		
		if (recv_flag==1) {
			c1=buf[0]; c2=buf[1]; c3=buf[2]; cnt=0;
			if ((c1>=0x30)&&(c1<=0x3f)) { d1=c1-0x30; cnt++; }
			if ((c2>=0x41)&&(c2<=0x50)) { d2=c2-0x41; cnt++; }
			if ((c3>=0x61)&&(c3<=0x70)) { d3=c3-0x61; cnt++; }
			if (cnt==3) {
				
				out1=0; out2=0; out3=0;
				if (d1 & 0x01) { out1 |= 0x01; } // up
				if (d1 & 0x02) { out1 |= 0x02; } // down
				if (d1 & 0x04) { out1 |= 0x04; } // left
				if (d1 & 0x08) { out1 |= 0x08; } // right
				if (d2 & 0x01) { out2 |= 0x01; } // o
				if (d2 & 0x02) { out2 |= 0x02; } // x
				if (d2 & 0x04) { out2 |= 0x04; } // triangle
				if (d2 & 0x08) { out2 |= 0x08; } // square
				if (d3 & 0x01) { out3 |= 0x01; } // start
				if (d3 & 0x02) { out3 |= 0x02; } // select
				if (d3 & 0x04) { out3 |= 0x04; } // L-trigger
				if (d3 & 0x08) { out3 |= 0x08; } // R-trigger
				
				PORTB = d1;
				PORTC = d2;
				PORTD = (d3 << 2);
				
				rs_puts(buf); rs_putc(0x0d); // echo back
			}
		}
		
	}
}
